import { PLACEHOLDER } from "./constants";
import { FunctionComponent, ReactElement } from "react";
import { OptionProps } from "../Option";
import { MarkedInputProps } from "./MarkedInput";
import { Trigger } from "./hooks/useTrigger";
export declare type Mark = {
    annotation: string;
    label: string;
    value: string;
    index: number;
    input: string;
    childIndex: number;
};
export interface OverlayProps {
    style: {
        left: number;
        top: number;
    };
    onSelect: onSelect;
    data: string[];
    word: string;
}
export interface MarkProps {
    label: string;
    value?: string;
}
export declare type onSelect = ({ label, value }: {
    label: string;
    value: string;
}) => void;
declare type label = `${string}${PLACEHOLDER.LABEL}${string}`;
declare type value = `${string}${PLACEHOLDER.VALUE}${string}`;
export declare type Markup = `${label}${value}` | `${label}`;
export declare type ElementOptions<T> = ReactElement<OptionProps<T>> | ReactElement<OptionProps<T>>[];
export declare type Slice<T> = string | Mark;
export declare type SliceMap<T> = Map<number, Slice<T>>;
declare type PartialPick<T, F extends keyof T> = Omit<Required<T>, F> & Partial<Pick<T, F>>;
export declare type OptionType = PartialPick<OptionProps, "initMark" | "initOverlay">;
export declare type Options = OptionType[];
export declare type ConfiguredMarkedInputProps<T, T1 = OverlayProps> = Omit<MarkedInputProps<T, T1>, "Mark" | "Overlay" | "children">;
export declare type ConfiguredMarkedInput<T, T1 = OverlayProps> = FunctionComponent<ConfiguredMarkedInputProps<T, T1>>;
export declare type Store = {
    props: MarkedInputProps<any, any>;
    options: Options;
    sliceMap: SliceMap<any>;
    dispatch: Dispatch;
    trigger: Trigger;
};
export declare type Dispatch = (type: Type, payload: Payload) => void;
export declare enum Type {
    Change = 0,
    Delete = 1
}
export declare type Action = {
    type: Type;
    payload: Payload;
};
export declare type Payload = {
    key: number;
    value?: Slice<any>;
};
export {};
//# sourceMappingURL=types.d.ts.map