import React from "react";
import { Mark, Markup, Options, ElementOptions, Store } from "../types";
import { OptionProps } from "../../Option";
export declare const assign: {
    <T, U>(target: T, source: U): T & U;
    <T_1, U_1, V>(target: T_1, source1: U_1, source2: V): T_1 & U_1 & V;
    <T_2, U_2, V_1, W>(target: T_2, source1: U_2, source2: V_1, source3: W): T_2 & U_2 & V_1 & W;
    (target: object, ...sources: any[]): any;
};
export declare const markupToRegex: (markup: Markup) => RegExp;
export declare const triggerToRegex: (value: string) => RegExp;
/**
 * Make annotation from the markup
 */
export declare function annotate(markup: Markup, label: string, value?: string): string;
/**
 * Transform the annotated text to the another text
 */
export declare function denote(value: string, callback: (mark: Mark) => string, ...markups: Markup[]): string;
export declare const escapeRegex: (str: string) => string;
export declare function toString(values: (string | Mark)[], options: Options): string;
export declare const normalizeMark: (mark: Mark, markup: Markup) => Mark;
export declare const genHash: (str: string, seed?: number) => number;
export declare const genId: () => string;
export declare const isObject: (value: unknown) => value is object;
export declare const isFunction: (value: unknown) => value is Function;
export declare function extractOptions(options?: ElementOptions<any> | OptionProps[]): Options;
export declare const useStore: () => Store, StoreProvider: React.Provider<Store>;
//# sourceMappingURL=index.d.ts.map